#include "mpi.h"
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>


int main(int argc, char **argv)
{
  int       myrank, mysize;
  MPI_Status status;
  int       istop[10],  recv_buf[10], irc, err;
  char     *commands;
  MPI_Comm  slave;
  char      portname[MPI_MAX_PORT_NAME];
  int nb_spawns=1000;
  int ib_do;


  MPI_Init(&argc, &argv);

  for(ib_do=1;ib_do<=nb_spawns;ib_do++) {
       
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Comm_size(MPI_COMM_WORLD, &mysize);
       
    istop[0] = 9999;
    
    /* spawn child processes */
    printf("spawn number : %d ... ", ib_do);
    commands = "slave";
    MPI_Comm_spawn(commands, MPI_ARGV_NULL, mysize, MPI_INFO_NULL,
		   0, MPI_COMM_WORLD, &slave, &err);
    printf("done\n");

    /* Receive port name from slave */
    irc = MPI_Recv(portname, MPI_MAX_PORT_NAME, MPI_BYTE, 0, 111, slave, &status);
    
    /* Send stop message to slave  */
    irc = MPI_Send(istop, 1, MPI_INT, 0, 999, slave);
    
    /*  Disconnect and Finalize  */
    MPI_Comm_disconnect(&slave);
    
  }
  MPI_Finalize();
  
  
}
